package gq.unurled.raxen.components.entity;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.player.attributes.Attribute;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;

public class Attributes {

    private static EntityNamespacedKey namespacedKey;

    public Attributes(Raxen main) {
        namespacedKey = new EntityNamespacedKey(main);
    }

    public static Attribute getAttribute(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        int maxHealth, health, itemHealth, defense, itemDefense, speed, itemSpeed, strength, itemDmg, maxMana, mana, itemMana, luck, itemLuck;
        maxHealth = data.get(namespacedKey.maxHealth, PersistentDataType.INTEGER);
        health = data.get(namespacedKey.healthKey, PersistentDataType.INTEGER);
        itemHealth = data.get(namespacedKey.itemHealthKey, PersistentDataType.INTEGER);
        defense = data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER);
        itemDefense = data.get(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER);
        speed = data.get(namespacedKey.speedKey, PersistentDataType.INTEGER);
        itemSpeed = data.get(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER);
        strength = data.get(namespacedKey.strengthKey , PersistentDataType.INTEGER);
        itemDmg = data.get(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER);
        maxMana = data.get(namespacedKey.maxMana, PersistentDataType.INTEGER);
        mana = data.get(namespacedKey.mana, PersistentDataType.INTEGER);
        itemMana = data.get(namespacedKey.itemMana, PersistentDataType.INTEGER);
        luck = data.get(namespacedKey.luck, PersistentDataType.INTEGER);
        itemLuck = data.get(namespacedKey.itemLuck, PersistentDataType.INTEGER);

        return new Attribute(maxHealth, health, itemHealth, defense, itemDefense, speed, itemSpeed, strength, itemDmg, maxMana, mana, itemMana, luck, itemLuck);
    }

    public static void setAttributes(Entity e, int health, int itemHealth, int defense, int itemDefense, int speed, int itemSpeed, int strength, int itemDmg, int maxMana, int mana, int itemMana, int luck, int itemLuck) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.healthKey, PersistentDataType.INTEGER, health);
        data.set(namespacedKey.itemHealthKey, PersistentDataType.INTEGER, itemHealth);
        data.set(namespacedKey.defenseKey, PersistentDataType.INTEGER, defense);
        data.set(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER, itemDefense);
        data.set(namespacedKey.speedKey, PersistentDataType.INTEGER, speed);
        data.set(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER, itemSpeed);
        data.set(namespacedKey.strengthKey , PersistentDataType.INTEGER, strength);
        data.set(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER, itemDmg);
        data.set(namespacedKey.maxMana, PersistentDataType.INTEGER, maxMana);
        data.set(namespacedKey.mana, PersistentDataType.INTEGER, mana);
        data.set(namespacedKey.itemMana, PersistentDataType.INTEGER, itemMana);
        data.set(namespacedKey.luck, PersistentDataType.INTEGER, luck);
        data.set(namespacedKey.itemLuck, PersistentDataType.INTEGER, itemLuck);
    }

    public void removeSpeed(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.speedKey, PersistentDataType.INTEGER, data.get(namespacedKey.speedKey, PersistentDataType.INTEGER) -i);
    }
    public void removeHealth(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.healthKey, PersistentDataType.INTEGER, data.get(namespacedKey.healthKey, PersistentDataType.INTEGER) -i);
    }
    public void removeDefense(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.defenseKey, PersistentDataType.INTEGER, data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER) -i);
    }
    public void removeStrength(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.strengthKey, PersistentDataType.INTEGER, data.get(namespacedKey.strengthKey, PersistentDataType.INTEGER) -i);
    }
    public void removeMana(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.mana, PersistentDataType.INTEGER, data.get(namespacedKey.mana, PersistentDataType.INTEGER) -i);
    }
    public void removeMaxMana(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.maxMana, PersistentDataType.INTEGER, data.get(namespacedKey.maxMana, PersistentDataType.INTEGER) -i);
    }
    public void removeMaxHealth(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.maxHealth, PersistentDataType.INTEGER, data.get(namespacedKey.maxHealth, PersistentDataType.INTEGER) -i);
    }
    public void removeLuck(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.luck, PersistentDataType.INTEGER, data.get(namespacedKey.luck, PersistentDataType.INTEGER) -i);
    }

    public void removeItemSpeed(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER) -i);
    }
    public void removeItemHealth(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemHealthKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemHealthKey, PersistentDataType.INTEGER) -i);
    }
    public void removeItemDefense(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER) -i);
    }
    public void removeItemStrength(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER) -i);
    }
    public void removeItemLuck(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemLuck, PersistentDataType.INTEGER, data.get(namespacedKey.itemLuck, PersistentDataType.INTEGER) -i);
    }


    public void addSpeed(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.speedKey, PersistentDataType.INTEGER, data.get(namespacedKey.speedKey, PersistentDataType.INTEGER) +i);
    }
    public void addHealth(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.healthKey, PersistentDataType.INTEGER, data.get(namespacedKey.healthKey, PersistentDataType.INTEGER) +i);
    }
    public void addDefense(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.defenseKey, PersistentDataType.INTEGER, data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER) +i);
    }
    public void addStrength(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.strengthKey, PersistentDataType.INTEGER, data.get(namespacedKey.strengthKey, PersistentDataType.INTEGER) +i);
    }
    public void addMana(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.mana, PersistentDataType.INTEGER, data.get(namespacedKey.mana, PersistentDataType.INTEGER) +i);
    }
    public void addMaxMana(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.maxMana, PersistentDataType.INTEGER, data.get(namespacedKey.maxMana, PersistentDataType.INTEGER) +i);
    }
    public void addMaxHealth(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.maxHealth, PersistentDataType.INTEGER, data.get(namespacedKey.maxHealth, PersistentDataType.INTEGER) +i);
    }
    public void addLuck(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.luck, PersistentDataType.INTEGER, data.get(namespacedKey.luck, PersistentDataType.INTEGER) +i);
    }

    public void addItemSpeed(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER) +i);
    }
    public void addItemHealth(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemHealthKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemHealthKey, PersistentDataType.INTEGER) +i);
    }
    public void addItemDefense(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER, data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER) +i);
    }
    public void addItemStrength(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER) +i);
    }
    public void addItemLuck(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemLuck, PersistentDataType.INTEGER, data.get(namespacedKey.itemLuck, PersistentDataType.INTEGER) +i);
    }

    public Integer getSpeed(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        return data.get(namespacedKey.speedKey, PersistentDataType.INTEGER);
    }
    public Integer getStrength(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        return data.get(namespacedKey.strengthKey, PersistentDataType.INTEGER);
    }
    public Integer getHealth(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        return data.get(namespacedKey.healthKey, PersistentDataType.INTEGER);
    }
    public Integer getDefense(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        return data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER);
    }
    public Integer getMana(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.mana, PersistentDataType.INTEGER);
    }
    public Integer getMaxMana(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.maxMana, PersistentDataType.INTEGER);
    }
    public Integer getMaxHealth(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.maxHealth, PersistentDataType.INTEGER);
    }
    public Integer getLuck(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.luck, PersistentDataType.INTEGER);
    }

    public Integer getItemSpeed(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        return data.get(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER);
    }
    public Integer getItemStrength(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        return data.get(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER);
    }
    public Integer getItemHealth(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        return data.get(namespacedKey.itemHealthKey, PersistentDataType.INTEGER);
    }
    public Integer getItemDefense(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        return data.get(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER);
    }
    public Integer getItemLuck(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        return data.get(namespacedKey.itemLuck, PersistentDataType.INTEGER);
    }

    public void setHealth(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.healthKey, PersistentDataType.INTEGER, i);
    }
    public void setDefense(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.defenseKey, PersistentDataType.INTEGER, i);
    }
    public void setSpeed(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.speedKey, PersistentDataType.INTEGER, i);
    }
    public void setStrength(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.strengthKey, PersistentDataType.INTEGER, i);
    }
    public void setMana(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.mana, PersistentDataType.INTEGER, i);
    }
    public void setMaxMana(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.maxMana, PersistentDataType.INTEGER, i);
    }
    public void setMaxHealth(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.maxHealth, PersistentDataType.INTEGER, i);
    }
    public void setLuck(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.luck, PersistentDataType.INTEGER, i);
    }

    public void setItemHealth(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemHealthKey, PersistentDataType.INTEGER, i);
    }
    public void setItemDefense(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER, i);
    }
    public void setItemSpeed(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER, i);
    }
    public void setItemStrength(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER, i);
    }
    public void setItemLuck(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemLuck, PersistentDataType.INTEGER, i);
    }
}
