package gq.unurled.raxen.manager;

import de.tr7zw.nbtapi.NBTItem;
import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.items.NBT;
import lombok.Getter;
import net.kyori.adventure.text.Component;
import org.bukkit.Material;
import org.bukkit.configuration.InvalidConfigurationException;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Objects;

import static gq.unurled.raxen.utils.Items.setLoreFromNBT;
import static gq.unurled.raxen.utils.Utils.*;

public class ItemManager {

    private final Raxen main;
    @Getter
    private HashMap<String, ItemStack> list = new HashMap<>();
    private NBT nbt = new NBT();

    public ItemManager(Raxen main) {
        this.main = main;
        register();
    }

    private void example() {
        File customFile;
        FileConfiguration customConfig;
        customFile = new File(main.getDataFolder() + "/Items/", "/example.yml");

        if (!customFile.exists()) {
            customFile.getParentFile().mkdirs();
            try {
                customFile.createNewFile();
            }
            catch (IOException e) {
                error("Error in Item Manager saving new File.");
                e.printStackTrace();
            }
        }
        customConfig = new YamlConfiguration();
        try {
            customConfig.load(customFile);
        } catch (IOException | InvalidConfigurationException e) {
            e.printStackTrace();
        }
        List<String> lore = new ArrayList<>();
        lore.add("&csuper lore wahou");
        if (customConfig.get("name") == null) {
            customConfig.set("id", "minecraft_id_of_item");
            customConfig.set("customId", "id_of_item_used_to_identify_it");
            customConfig.set("name", "&cName of the Item");
            customConfig.set("health", 100);
            customConfig.set("defense", 50);
            customConfig.set("speed", 100);
            customConfig.set("strength", 100);
            customConfig.set("custom_ability","fireball");
            customConfig.set("custom_model_data", 123);
            customConfig.set("lore",lore);
            try {
                customConfig.save(customFile);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    private void register() {
        File folder = new File(main.getDataFolder() + "/Items/");
        File[] listFile = folder.listFiles();

        for (int i = 0; i < listFile.length; i++) {
            if (listFile[i].isFile()) {
                FileConfiguration customItem = new YamlConfiguration();
                try {
                    customItem.load(listFile[i]);
                } catch (IOException | InvalidConfigurationException e) {
                    e.printStackTrace();
                }
                registerItem(customItem);
            } else if (listFile[i].isDirectory()) {
                for (int a = 0; a < listFile[i].listFiles().length; a++) {
                    if(listFile[i].listFiles()[a].isFile()) {
                        FileConfiguration customItem = new YamlConfiguration();
                        try {
                            customItem.load(listFile[i].listFiles()[a]);
                        } catch (IOException | InvalidConfigurationException e) {
                            e.printStackTrace();
                        }
                        registerItem(customItem);
                    } else if (listFile[i].listFiles()[a].isDirectory()) {
                        error("Can't use more than 2 folder to get Items.yml");
                    }

                }
            }
        }
    }

    private void registerItem(FileConfiguration file) {
        debug(file.getString("id"));
        ItemStack it = new ItemStack(Material.getMaterial((String) file.get("id")));
        ItemMeta itm = it.getItemMeta();
        itm.displayName(Component.text(color((String) file.get("name"))));
        List<Component> lore = new ArrayList<>();
        for (String str : (List<String>) Objects.requireNonNull(file.get("lore"))) {
            lore.add(Component.text(color(str)));
        }
        itm.setCustomModelData(file.getConfigurationSection("Pack").getInt("custom_model_data"));
        itm.lore(lore);
        it.setItemMeta(itm);
        NBTItem nbti = new NBTItem(it);
        nbti.setInteger(NBT.SPEED, file.getInt("speed"));
        nbti.setInteger(NBT.HEALTH, file.getInt("health"));
        nbti.setInteger(NBT.DEFENSE, file.getInt("defense"));
        nbti.setInteger(NBT.STRENGTH, file.getInt("strength"));
        nbti.setString(NBT.ID, file.getString("customId"));
        nbti.setString(NBT.CUSTOM_ABILITY, file.getString("custom_ability"));
        nbti.setDouble(NBT.DROP_RATE, file.getDouble("drop_rate"));
        it = nbti.getItem();
        it = setLoreFromNBT(it);
        list.put(file.getString("customId"), it);
    }
}
