package gq.unurled.raxen.utils;

import gq.unurled.raxen.Raxen;
import net.kyori.adventure.text.Component;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Material;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;

import java.util.logging.Logger;

public class Utils {

    private static final Logger logger = Raxen.getPluginLogger();

    public static String color(String string) {
        return ChatColor.translateAlternateColorCodes('&', string);
    }

    public static String decolor(String string) {
        return ChatColor.stripColor(color(string));
    }

    /**
     * debug output to console if debug is set to true in config
     * @param main Raxen instance
     * @param strings ouptut to console
     */
    public static void debug(Raxen main, String... strings) {
        FileConfiguration config = main.getConfig();
        if(config.getBoolean("debug")) {
            for(String string : strings) {
                logger.info(string);
            }
        }
    }

    /**
     * debug output to console if debug is set to true in config
     * @param strings output to console
     */
    public static void debug(String... strings) {
        Raxen main = (Raxen) Bukkit.getPluginManager().getPlugin("Raxen");
        FileConfiguration config = main.getConfig();
        if(config.getBoolean("debug")) {
            for(String string : strings) {
                logger.info(string);
            }
        }
    }
    /**
     * debug output to console if debug is set to true in config
     * @param config main file config
     * @param strings ouput to console
     */
    public static void debug(FileConfiguration config, String... strings) {
        if(config.getBoolean("debug")) {
            for(String string : strings) {
                logger.info(string);
            }
        }
    }

    public static void log(String... strings) {
        for(String string : strings) {
            logger.info(string);
        }
    }

    public static void warn(String... strings) {
        for(String string : strings) {
            logger.warning(string);
        }
    }

    public static void error(String... strings) {
        for(String string : strings) {
            logger.severe(string);
        }
    }

    public static void msgPlayer(Player player, String... strings) {
        for(String string : strings) {
            player.sendMessage(Component.text(color(string)));
        }
    }

    public static Inventory fillGreyPane(Inventory inv) {
        Integer in = -1;
        for (ItemStack it : inv) {
            in++;
            if (it == null || it.getType() == Material.AIR) {
                inv.setItem(in, Items.greyPane());
            }
        }
        return inv;
    }

    public static Component noPerms() {
        return Component.text(color("&cYou don't have the permission to use this feature."));
    }

    public static Component error() {
        return Component.text(color("&cAn Error has occurred. Please retry or contact an Admin."));
    }



}
